Magellan Linux

Diff of /branches/mage-next/src/mage4.functions.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1590 by niro, Thu Dec 29 15:12:05 2011 UTC revision 2270 by niro, Fri Oct 25 07:16:09 2013 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2  # Magellan Linux Installer Functions (mage.functions.sh)  # Magellan Linux Installer Functions (mage.functions.sh)
3  # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/mage4.functions.sh,v 1.38 2008-10-05 10:32:24 niro Exp $  # $Id$
4    
5  COLRED="\033[1;6m\033[31m"  COLRED="\033[1;6m\033[31m"
6  COLGREEN="\033[1;6m\033[32m"  COLGREEN="\033[1;6m\033[32m"
# Line 46  mchecksum() Line 46  mchecksum()
46   local method   local method
47   local cmd   local cmd
48   local retval   local retval
49     local sum
50     local dest
51    
52   # very basic getops   # very basic getops
53   for i in $*   for i in $*
# Line 66  mchecksum() Line 68  mchecksum()
68   case ${method} in   case ${method} in
69   md5) cmd="md5sum" ;;   md5) cmd="md5sum" ;;
70   sha256) cmd="sha256sum" ;;   sha256) cmd="sha256sum" ;;
71   *) die "mchecksum(): unkown method '${method}'" ;;   *) die "mchecksum(): unknown method '${method}'" ;;
72   esac   esac
73    
74   if [[ -d ${rundir} ]]   if [[ -d ${rundir} ]]
75   then   then
76   pushd ${rundir} &> /dev/null   pushd ${rundir} &> /dev/null
77   ${cmd} -c ${file} &> /dev/null  
78   retval="$?"   # all file must be non-zero
79     retval=0
80     while read sum dest
81     do
82     if [ ! -s ${dest} ]
83     then
84     echo "${dest}: file is empty ;("
85     retval=127
86     fi
87     done < ${file}
88     if [[ ${retval} != 127 ]]
89     then
90     # be verbose here
91     ${cmd} -c ${file} #&> /dev/null
92     retval="$?"
93     fi
94    
95   popd &> /dev/null   popd &> /dev/null
96   else   else
97   retval=1   retval=1
# Line 82  mchecksum() Line 100  mchecksum()
100   return "${retval}"   return "${retval}"
101  }  }
102    
103    mcheckemptydir()
104    {
105     local dir="$1"
106     local retval=1
107    
108     if [[ ! -d ${dir} ]]
109     then
110     echo "mcheckemptydir(): '${dir}' is not a directory!"
111     retval=3
112     else
113     shopt -s nullglob dotglob
114     files=( ${dir}/* )
115     (( ${#files[*]} )) || retval=0
116     shopt -u nullglob dotglob
117     fi
118    
119     return ${retval}
120    }
121    
122    unpack_package()
123    {
124     local magefile="$1"
125     local pkg
126     local pkgtype
127     local tar_opts
128    
129     pkg="$(get_value_from_magefile PKGNAME ${magefile}).${PKGSUFFIX}"
130     pkgtype="$(get_value_from_magefile PKGTYPE ${magefile})"
131    
132     xtitle "[ Unpacking ${pkg} ]"
133    
134     # abort on virtual pkg
135     if [[ ${pkgtype} = virtual ]]
136     then
137     echo -ne " ${COLBLUE}---${COLDEFAULT}"
138     echo " !unpack virtual ${pkg/.${PKGSUFFIX}/} ... "
139     continue
140     fi
141    
142     # abort on sources pkg
143     if [[ ${pkgtype} = sources ]]
144     then
145     echo -ne " ${COLBLUE}---${COLDEFAULT}"
146     echo " !unpack sources ${pkg/.${PKGSUFFIX}/} ... "
147     continue
148     fi
149    
150     # busybox?
151     if need_busybox_support tar
152     then
153     tar_opts="xjf"
154     else
155     tar_opts="xjmf"
156     fi
157    
158     echo -e " ${COLBLUE}***${COLDEFAULT} unpacking ${pkg} ... "
159     tar ${tar_opts} ${PKGDIR}/${pkg} -C ${BUILDDIR} || die "Unpacking package ${pkg}"
160    }
161    
162  unpack_packages()  unpack_packages()
163  {  {
164   local list="$@"   local list="$@"
165   local magefile   local magefile
  local pkg  
  local pkgtype  
166   local count_current   local count_current
167   local count_total   local count_total
168   local tar_opts   local tar_opts
# Line 100  unpack_packages() Line 175  unpack_packages()
175    
176   for magefile in ${list}   for magefile in ${list}
177   do   do
178   pkg="$(get_value_from_magefile PKGNAME ${magefile}).${PKGSUFFIX}"   unpack_package "${magefile}"
  pkgtype="$(get_value_from_magefile PKGTYPE ${magefile})"  
   
179   (( count_current++ ))   (( count_current++ ))
  xtitle "[ (${count_current}/${count_total}) Unpacking ${pkg} ]"  
   
  # abort on virtual pkg  
  if [[ ${pkgtype} = virtual ]]  
  then  
  echo -ne " ${COLBLUE}---${COLDEFAULT}"  
  echo " !unpack virtual (${count_current}/${count_total}): ${pkg/.${PKGSUFFIX}/} ... "  
  continue  
  fi  
   
  # abort on sources pkg  
  if [[ ${pkgtype} = sources ]]  
  then  
  echo -ne " ${COLBLUE}---${COLDEFAULT}"  
  echo " !unpack sources (${count_current}/${count_total}): ${pkg/.${PKGSUFFIX}/} ... "  
  continue  
  fi  
   
  # busybox?  
  if need_busybox_support tar  
  then  
  tar_opts="xjf"  
  else  
  tar_opts="xjmf"  
  fi  
   
  echo -e " ${COLBLUE}***${COLDEFAULT} unpacking (${count_current}/${count_total}): ${pkg} ... "  
  tar ${tar_opts} ${PKGDIR}/${pkg} -C ${BUILDDIR} || die "Unpacking package ${pkg}"  
180   done   done
181    
182   # add a crlf for a better view   # add a crlf for a better view
# Line 151  fix_mtime() Line 196  fix_mtime()
196   mtime=$(stat -c %Y "${reference}")   mtime=$(stat -c %Y "${reference}")
197   touch \   touch \
198   --no-create \   --no-create \
199     --no-dereference \
200   --time=mtime \   --time=mtime \
201   --reference "${reference}" \   --reference="${reference}" \
202   "${pathto}"   "${pathto}"
203    
204   echo "${mtime}"   echo "${mtime}"
# Line 394  install_symlinks() Line 440  install_symlinks()
440    
441   ln -snf "${link}" "${MROOT}${pathto}"   ln -snf "${link}" "${MROOT}${pathto}"
442    
443  # # fix mtime and db   # fix mtime and db
444  # fix_descriptor ${pkgname}/.symlinks \   fix_descriptor ${pkgname}/.symlinks \
445  # "${pathto}" \   "${pathto}" \
446  # "${posix}" \   "${posix}" \
447  # "${link}" \   "${link}" \
448  # "$(fix_mtime "${BUILDDIR}/${pkgname}"/.mtime \   "$(fix_mtime "${BUILDDIR}/${pkgname}"/.mtime \
449  # "${MROOT}${pathto}")"   "${MROOT}${pathto}")"
450    
451   done < ${BUILDDIR}/${pkgname}/.symlinks   done < ${BUILDDIR}/${pkgname}/.symlinks
452    
# Line 787  compare_mtime() Line 833  compare_mtime()
833    
834   mtime="$(stat -c %Y ${MROOT}${INSTALLDB}/${pfull}/.mtime)"   mtime="$(stat -c %Y ${MROOT}${INSTALLDB}/${pfull}/.mtime)"
835    
836   # if $pathto is a symlink than compare linked binary   # no extra handlink for symlinks anymore as fix_mtime
837   if [ -L "${MROOT}${pathto}" ]   # uses --no-dereference, compare directly
838   then   x=$(stat -c %Y "${MROOT}${pathto}")
  # readlink -f resolves full path of linked file  
  x="$(readlink -f "${MROOT}${pathto}")"  
   
  # abort if target does not exists  
  # we keep safe here, theoretically the link can removed  
  [ ! -e "${x}" ] && return 1  
   
  x=$(stat -c %Y "${x}")  
  else  
  x=$(stat -c %Y "${MROOT}${pathto}")  
  fi  
839    
840   [[ ${mtime} = ${x} ]] && return 0   [[ ${mtime} = ${x} ]] && return 0
841    
# Line 1366  convertmirrors() Line 1401  convertmirrors()
1401   output+="${mirror}${addon}/${uri/${scheme}/}"   output+="${mirror}${addon}/${uri/${scheme}/}"
1402   done   done
1403   else   else
1404   output="${uri}"   output="${uri}"
1405   fi   fi
1406    
1407   echo "${output}"   echo "${output}"
# Line 1401  mdownload() Line 1436  mdownload()
1436   real_uris="$(convertmirrors ${uri})"   real_uris="$(convertmirrors ${uri})"
1437    
1438   # verbose or not   # verbose or not
1439   mqueryfeature "!verbose" && wget_opts="--quiet"   mqueryfeature "!verbose" && wget_opts+=" --quiet"
1440    
1441   # filter wget options if busybox was found   # filter wget options if busybox was found
1442   wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"   wget_opts+=" $(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"
1443    
1444   # create outputdir   # create outputdir
1445   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"
# Line 1545  syncmage_tarball() Line 1580  syncmage_tarball()
1580    
1581   for mirr in ${MIRRORS}   for mirr in ${MIRRORS}
1582   do   do
1583   # path without distribution   # path without distribution
1584   mymirr="${mirr%/*}"   # (only for stable|testing|unstable and not DISTROTAG)
1585     case ${mirr##*/} in
1586     stable|testing|unstable) mymirr="${mirr%/*}";;
1587     *) mymirr="${mirr}";;
1588     esac
1589    
1590   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1591   echo "fetching latest md5 from ${mymirr} ..."   echo "fetching latest md5 from ${mymirr} ..."
# Line 1579  syncmage_tarball() Line 1618  syncmage_tarball()
1618   else   else
1619   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1620   echo -n "checking md5sum... "   echo -n "checking md5sum... "
1621   ( cd ${temp}; md5sum -c ${latest_md5} ) || die "md5 for ${latest_tarball} failed"   mchecksum --rundir "${temp}" --file "${latest_md5}" --method md5 || die "md5 for ${latest_tarball} failed"
1622   fi   fi
1623    
1624   if [[ -d ${MAGEDIR} ]]   if [[ -d ${MAGEDIR} ]]
1625   then   then
1626   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1627   echo "cleaning old mage-tree ${MAGEDIR}..."   echo "cleaning old mage-tree ${MAGEDIR}..."
1628   rm -rf ${MAGEDIR}   # honor mountpoints and empty dirs
1629     if mountpoint -q ${MAGEDIR}
1630     then
1631     if ! mcheckemptydir ${MAGEDIR}
1632     then
1633     find ${MAGEDIR} -mindepth 1 -maxdepth 1 | xargs --no-run-if-empty rm -r
1634     fi
1635     else
1636     rm -rf ${MAGEDIR}
1637     fi
1638   fi   fi
1639    
1640   if need_busybox_support tar   if need_busybox_support tar
# Line 1645  xtitleclean() Line 1693  xtitleclean()
1693  }  }
1694    
1695    
1696  # cuts full pathnames or versionized names down to basename  # unused?
1697  choppkgname()  #
1698  {  # # cuts full pathnames or versionized names down to basename
1699   #we want this only if full name was used  # choppkgname()
1700   if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]  # {
1701   then  # #we want this only if full name was used
1702   #cuts ARCH and PBUILD  # if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]
1703   #ARCH comes from ${MAGERC}  # then
1704   MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}-r*.::g")  # #cuts ARCH and PBUILD
1705    # #ARCH comes from ${MAGERC}
1706    # MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}$(print_distrotag)-r*.::g")
1707    #
1708    # #cuts version number
1709    # MAGENAME=$(basename ${MAGENAME%-*} .mage)
1710    # fi
1711    # }
1712    
  #cuts version number  
  MAGENAME=$(basename ${MAGENAME%-*} .mage)  
  fi  
 }  
1713    
1714  # get_categorie $PNAME, returns CATEGORIE  # get_categorie $PNAME, returns CATEGORIE
1715  # $1=pname  # $1=pname
# Line 1737  get_highest_magefile() Line 1788  get_highest_magefile()
1788   then   then
1789   HIGHEST_MAGEFILE=${magefile}   HIGHEST_MAGEFILE=${magefile}
1790   #for debug only   #for debug only
1791   mqueryfeature "debug" && echo "HIGHEST_MAGEFILE=${HIGHEST_MAGEFILE}"   mqueryfeature "debug" && echo "HIGHEST_MAGEFILE=${HIGHEST_MAGEFILE}" >&2
1792   fi   fi
1793   done   done
1794    
# Line 1844  count_protected_files() Line 1895  count_protected_files()
1895   local filename="${file##*/}"   local filename="${file##*/}"
1896   local count   local count
1897   local output   local output
1898     local oldprotected
1899   local i   local i
1900     local x
1901    
1902   declare -i count=0   # hack; do not honor a global set IFS like '§'
1903     local IFS
1904    
1905     count=0
1906    
1907   # check if there are already protected files   # check if there are already protected files
1908   for oldpretected in $(find ${dirname} -iname "._cfg????_${filename}" |   for oldprotected in $(find ${dirname} -iname "._cfg????_${filename}" |
1909   sed -e "s:\(^.*/\)\(._cfg*_\)\(/.*$\):\1\2\3\%\2\%\3:" |   sed -e "s:\(^.*/\)\(._cfg*_\)\(/.*$\):\1\2\3\%\2\%\3:" |
1910   sort -t'%' -k3 -k2 | cut -f1 -d'%')   sort -t'%' -k3 -k2 | cut -f1 -d'%')
1911   do   do
1912   count=$(echo ${oldpretected} | cut -d_ -f2 | sed -e "s:cfg::")   count="$(echo ${oldprotected} | sed 's:.*\/._cfg\(.*\)_.*:\1:')"
1913     done
1914    
1915     # convert 0001 -> 1; 0120 -> 120 etc
1916     # use bash internal base functions to this task
1917     x="$((10#${count}))"
1918     for (( i=0; i<x; i++ ))
1919     do
1920     if [[ ${count:${i}:1} != 0 ]]
1921     then
1922     count="${count:${i}}"
1923     break
1924     fi
1925   done   done
1926   (( count ++ ))  
1927     count="$(( ${count}+1 ))"
1928    
1929   # fill output up with zeros   # fill output up with zeros
1930   for (( i=${#count}; i < 4; i++ )); do output="${output}0"; done   for (( i=${#count}; i < 4; i++ )); do output="${output}0"; done
# Line 2645  mage_install() Line 2714  mage_install()
2714   if [[ ${PKGTYPE} != virtual ]] && \   if [[ ${PKGTYPE} != virtual ]] && \
2715   [[ ${PKGTYPE} != sources ]]   [[ ${PKGTYPE} != sources ]]
2716   then   then
2717     unpack_package "${magefile}"
2718   echo -e " ${COLBLUE}***${COLDEFAULT} merging files into system ... "   echo -e " ${COLBLUE}***${COLDEFAULT} merging files into system ... "
2719   build_doinstall ${PKGNAME}   build_doinstall ${PKGNAME}
2720   fi   fi
# Line 2759  md5sum_packages() Line 2829  md5sum_packages()
2829   then   then
2830   echo -ne "${COLBLUE} *** ${COLDEFAULT}"   echo -ne "${COLBLUE} *** ${COLDEFAULT}"
2831   echo -ne "checking md5sum (${count_current}/${count_total}): "   echo -ne "checking md5sum (${count_current}/${count_total}): "
2832   ( cd ${PKGDIR}; md5sum -c ${md5file}) || die "md5 for ${pkgfile} failed"   mchecksum --rundir "${PKGDIR}" --file "${md5file}" --method md5 || die "md5 for ${pkgfile} failed"
2833   else   else
2834   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
2835   echo -e "!! no md5sum file found for ${pkgfile} :("   echo -e "!! no md5sum file found for ${pkgfile} :("
# Line 2799  uninstall_packages() Line 2869  uninstall_packages()
2869   pbuild=$(magename2pbuild ${pkg})   pbuild=$(magename2pbuild ${pkg})
2870   can_pcat="${pcat}"   can_pcat="${pcat}"
2871   can_pname="${pname}"   can_pname="${pname}"
2872    
2873   if [ -z "${can_ver_list}" ]   if [ -z "${can_ver_list}" ]
2874   then   then
2875   can_ver_list=" ${pver}-${pbuild}"   can_ver_list=" ${pver}-${pbuild}"
# Line 2999  pkgsearch() Line 3069  pkgsearch()
3069   local state   local state
3070   local descriptiom   local descriptiom
3071   local homepage   local homepage
3072     local license
3073   local i   local i
3074   local all_installed   local all_installed
3075   local ipver   local ipver
# Line 3035  pkgsearch() Line 3106  pkgsearch()
3106   state="$(get_value_from_magefile STATE ${magefile})"   state="$(get_value_from_magefile STATE ${magefile})"
3107   description="$(get_value_from_magefile DESCRIPTION ${magefile})"   description="$(get_value_from_magefile DESCRIPTION ${magefile})"
3108   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"
3109     license="$(get_value_from_magefile LICENSE ${magefile})"
3110    
3111   # all installed   # all installed
3112   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})
3113   do   do
3114   ipver="$(magename2pver ${i})"   ipver="$(magename2pver ${i})"
3115   ipbuild="$(magename2pbuild ${i})"   ipbuild="$(magename2pbuild ${i})"
3116    
3117   if [[ -z ${all_installed} ]]   if [[ -z ${all_installed} ]]
3118   then   then
3119   all_installed="${ipver}-${ipbuild}"   all_installed="${ipver}-${ipbuild}"
# Line 3050  pkgsearch() Line 3122  pkgsearch()
3122   fi   fi
3123   done   done
3124   [[ -z ${all_installed} ]] && all_installed="none"   [[ -z ${all_installed} ]] && all_installed="none"
3125    
3126   case ${state} in   case ${state} in
3127   stable) state=${COLGREEN}"[s] ";;   stable) state=${COLGREEN}"[s] ";;
3128   testing) state=${COLYELLOW}"[t] ";;   testing) state=${COLYELLOW}"[t] ";;
# Line 3074  pkgsearch() Line 3146  pkgsearch()
3146   "") continue;;   "") continue;;
3147   esac   esac
3148    
3149   deps="${deps} $(basename ${dep%-*})"   if [[ -z ${deps} ]]
3150     then
3151     deps="$(basename ${dep%-*})"
3152     else
3153     deps="${deps} $(basename ${dep%-*})"
3154     fi
3155   done << EOF   done << EOF
3156  ${depsfull}  ${depsfull}
3157  EOF  EOF
# Line 3085  EOF Line 3162  EOF
3162   "") continue;;   "") continue;;
3163   esac   esac
3164    
3165   sdeps="${sdeps} $(basename ${dep%-*})"   if [[ -z ${sdeps} ]]
3166     then
3167     sdeps="$(basename ${dep%-*})"
3168     else
3169     sdeps="${sdeps} $(basename ${dep%-*})"
3170     fi
3171   done << EOF   done << EOF
3172  ${sdepsfull}  ${sdepsfull}
3173  EOF  EOF
# Line 3095  EOF Line 3177  EOF
3177   echo "      Installed versions: ${all_installed}"   echo "      Installed versions: ${all_installed}"
3178   echo "      Description: ${description}"   echo "      Description: ${description}"
3179   echo "      Homepage: ${homepage}"   echo "      Homepage: ${homepage}"
3180   echo "      Depends: ${deps}"   if [[ ! -z ${license} ]]
3181     then
3182     echo "      License:  ${license}"
3183     fi
3184     echo "      Depends:  ${deps}"
3185   echo "      SDepends: ${sdeps}"   echo "      SDepends: ${sdeps}"
3186   echo   echo
3187    
# Line 3212  EOF Line 3298  EOF
3298  need_busybox_support()  need_busybox_support()
3299  {  {
3300   local cmd   local cmd
3301     local busybox
3302   cmd="$1"   cmd="$1"
3303    
3304   if [[ -x /bin/busybox ]]   for busybox in {,/usr}/bin/busybox
3305   then   do
3306   if [[ $(readlink $(which ${cmd})) = /bin/busybox ]]   if [[ -x ${busybox} ]]
3307   then   then
3308   # needs busybox support   if [[ $(readlink $(type -P ${cmd})) = ${busybox} ]]
3309   return 0   then
3310     # needs busybox support
3311     return 0
3312     fi
3313   fi   fi
3314   fi   done
3315    
3316   # no busybox   # no busybox
3317   return 1   return 1
# Line 3278  known_mage_feature() Line 3368  known_mage_feature()
3368  {  {
3369   local feature="$1"   local feature="$1"
3370   local retval   local retval
3371    
3372   case "${feature}" in   case "${feature}" in
3373   autosvc|!autosvc) retval=0 ;;   autosvc|!autosvc) retval=0 ;;
3374   buildlog|!buildlog) retval=0 ;;   buildlog|!buildlog) retval=0 ;;
3375   ccache|!ccache) retval=0 ;;   ccache|!ccache) retval=0 ;;
3376   check|!check) retval=0 ;;   check|!check) retval=0 ;;
3377   compressdoc|!compressdoc) retval=0 ;;   compressdoc|!compressdoc) retval=0 ;;
3378     debug|!debug) retval=0 ;;
3379   distcc|!distcc) retval=0 ;;   distcc|!distcc) retval=0 ;;
3380     icecc|!icecc) retval=0 ;;
3381   kernelsrcunpack|!kernelsrcunpack) retval=0 ;;   kernelsrcunpack|!kernelsrcunpack) retval=0 ;;
3382   libtool|!libtool) retval=0 ;;   libtool|!libtool) retval=0 ;;
3383   linuxsymlink|!linuxsymlink) retval=0 ;;   linuxsymlink|!linuxsymlink) retval=0 ;;
3384   pkgbuild|!pkgbuild) retval=0 ;;   pkgbuild|!pkgbuild) retval=0 ;;
3385     pkgdistrotag|!pkgdistrotag) retval=0 ;;
3386   purge|!purge) retval=0 ;;   purge|!purge) retval=0 ;;
3387   qalint|!qalint) retval=0 ;;   qalint|!qalint) retval=0 ;;
3388   regentree|!regentree) retval=0 ;;   regentree|!regentree) retval=0 ;;
3389   stepbystep|!stepbystep) retval=0 ;;   resume|!resume) retval=0 ;;
3390   srcpkgbuild|!srcpkgbuild) retval=0 ;;   srcpkgbuild|!srcpkgbuild) retval=0 ;;
3391   srcpkgtarball|!srcpkgtarball) retval=0 ;;   srcpkgtarball|!srcpkgtarball) retval=0 ;;
3392     static|!static) retval=0 ;;
3393     stepbystep|!stepbystep) retval=0 ;;
3394   strip|!strip) retval=0 ;;   strip|!strip) retval=0 ;;
3395     verbose|!verbose) retval=0 ;;
3396   *) retval=1 ;;   *) retval=1 ;;
3397   esac   esac
3398    
# Line 3305  known_mage_feature() Line 3401  known_mage_feature()
3401    
3402  load_mage_features()  load_mage_features()
3403  {  {
  echo -en "${COLBLUE}---${COLGREEN} Loading mage-features... ${COLDEFAULT}"  
3404   for i in ${MAGE_FEATURES_GLOBAL[*]} ${MAGE_FEATURES[*]}   for i in ${MAGE_FEATURES_GLOBAL[*]} ${MAGE_FEATURES[*]}
3405   do   do
3406   FVERBOSE=off msetfeature ${i}   FVERBOSE=off msetfeature ${i}
3407   done   done
   
  echo -e "${COLGREEN}done${COLDEFAULT}"  
3408  }  }
3409    
3410  msetfeature()  msetfeature()
# Line 3328  msetfeature() Line 3421  msetfeature()
3421    
3422   if ! known_mage_feature "${feature}"   if ! known_mage_feature "${feature}"
3423   then   then
3424   [[ ${FVERBOSE} = off ]] || echo "unkown feature ${feature}, ignoring it"   [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3425   return 3   return 3
3426   fi   fi
3427    
# Line 3336  msetfeature() Line 3429  msetfeature()
3429   do   do
3430   if [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature} ]]   if [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature} ]]
3431   then   then
3432   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' already enabled"   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' already enabled${COLDEFAULT}"
3433   MAGE_FEATURES_CURRENT[${i}]="${feature}"   MAGE_FEATURES_CURRENT[${i}]="${feature}"
3434   found=1   found=1
3435   elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = !${feature} ]]   elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = !${feature} ]]
3436   then   then
3437   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' currently disabled, enabling it!"   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' currently disabled, enabling it!${COLDEFAULT}"
3438   MAGE_FEATURES_CURRENT[${i}]="${feature}"   MAGE_FEATURES_CURRENT[${i}]="${feature}"
3439   found=1   found=1
3440   elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature//!} ]]   elif [[ ${MAGE_FEATURES_CURRENT[${i}]} = ${feature//!} ]]
3441   then   then
3442   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature//!}' currently enabled, disabling it!"   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature//!}' currently enabled, disabling it!${COLDEFAULT}"
3443   MAGE_FEATURES_CURRENT[${i}]="${feature}"   MAGE_FEATURES_CURRENT[${i}]="${feature}"
3444   found=1   found=1
3445   fi   fi
# Line 3356  msetfeature() Line 3449  msetfeature()
3449   # it was not declared. in this case enable it   # it was not declared. in this case enable it
3450   if [[ ${found} = 0 ]]   if [[ ${found} = 0 ]]
3451   then   then
3452   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' was not declared, enabling it!"   [[ ${FVERBOSE} = off ]] || echo -e "${COLBLUE}---${COLGREEN} Feature '${feature}' was not declared, enabling it!${COLDEFAULT}"
3453   MAGE_FEATURES_CURRENT=( ${MAGE_FEATURES_CURRENT[*]} "${feature}" )   MAGE_FEATURES_CURRENT=( ${MAGE_FEATURES_CURRENT[*]} "${feature}" )
3454   fi   fi
3455    
# Line 3381  mqueryfeature() Line 3474  mqueryfeature()
3474   fi   fi
3475   done   done
3476   else   else
3477     [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3478   retval=3   retval=3
3479   fi   fi
3480    
# Line 3389  mqueryfeature() Line 3483  mqueryfeature()
3483    
3484  mprintfeatures()  mprintfeatures()
3485  {  {
3486   echo "Global features:  ${MAGE_FEATURES_GLOBAL[*]}"   echo -e "${COLRED}Global features:${COLDEFAULT} ${MAGE_FEATURES_GLOBAL[*]}"
3487   echo "Local features:   ${MAGE_FEATURES[*]}"   echo -e "${COLYELLOW}Local features:${COLDEFAULT} ${MAGE_FEATURES[*]}"
3488   echo "Current features: ${MAGE_FEATURES_CURRENT[*]}"   echo -e "${COLGREEN}Current features:${COLDEFAULT} ${MAGE_FEATURES_CURRENT[*]}"
3489  }  }

Legend:
Removed from v.1590  
changed lines
  Added in v.2270